Index: code/branches/objecthierarchy2/visual_studio/vc8/orxonox.vcproj
===================================================================
--- code/branches/objecthierarchy2/visual_studio/vc8/orxonox.vcproj	(revision 2172)
+++ code/branches/objecthierarchy2/visual_studio/vc8/orxonox.vcproj	(revision 2364)
@@ -210,4 +210,8 @@
 				</File>
 				<File
+					RelativePath="..\..\src\orxonox\objects\GlobalShader.cc"
+					>
+				</File>
+				<File
 					RelativePath="..\..\src\orxonox\objects\Level.cc"
 					>
@@ -247,20 +251,4 @@
 						RelativePath="..\..\src\orxonox\objects\worldentities\Backlight.cc"
 						>
-						<FileConfiguration
-							Name="Debug|Win32"
-							ExcludedFromBuild="true"
-							>
-							<Tool
-								Name="VCCLCompilerTool"
-							/>
-						</FileConfiguration>
-						<FileConfiguration
-							Name="Release|Win32"
-							ExcludedFromBuild="true"
-							>
-							<Tool
-								Name="VCCLCompilerTool"
-							/>
-						</FileConfiguration>
 					</File>
 					<File
@@ -282,4 +270,8 @@
 					<File
 						RelativePath="..\..\src\orxonox\objects\worldentities\ControllableEntity.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\FadingBillboard.cc"
 						>
 					</File>
@@ -361,4 +353,8 @@
 					>
 					<File
+						RelativePath="..\..\src\orxonox\objects\infos\Bot.cc"
+						>
+					</File>
+					<File
 						RelativePath="..\..\src\orxonox\objects\infos\HumanPlayer.cc"
 						>
@@ -377,4 +373,12 @@
 					>
 					<File
+						RelativePath="..\..\src\orxonox\objects\controllers\AIController.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\controllers\ArtificialController.cc"
+						>
+					</File>
+					<File
 						RelativePath="..\..\src\orxonox\objects\controllers\Controller.cc"
 						>
@@ -382,4 +386,8 @@
 					<File
 						RelativePath="..\..\src\orxonox\objects\controllers\HumanController.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\controllers\ScriptController.cc"
 						>
 					</File>
@@ -605,4 +613,20 @@
 					</File>
 				</Filter>
+				<Filter
+					Name="items"
+					>
+					<File
+						RelativePath="..\..\src\orxonox\objects\items\Engine.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\items\Item.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\items\MultiStateEngine.cc"
+						>
+					</File>
+				</Filter>
 			</Filter>
 			<Filter
@@ -619,4 +643,8 @@
 				<File
 					RelativePath="..\..\src\orxonox\tools\ParticleInterface.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\orxonox\tools\Shader.cc"
 					>
 				</File>
@@ -854,4 +882,8 @@
 				</File>
 				<File
+					RelativePath="..\..\src\orxonox\objects\GlobalShader.h"
+					>
+				</File>
+				<File
 					RelativePath="..\..\src\orxonox\objects\Level.h"
 					>
@@ -910,4 +942,8 @@
 					<File
 						RelativePath="..\..\src\orxonox\objects\worldentities\ControllableEntity.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\FadingBillboard.h"
 						>
 					</File>
@@ -989,4 +1025,12 @@
 					>
 					<File
+						RelativePath="..\..\src\orxonox\objects\infos\Bot.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\infos\HumanPlayer.h"
+						>
+					</File>
+					<File
 						RelativePath="..\..\src\orxonox\objects\infos\Info.h"
 						>
@@ -1001,4 +1045,12 @@
 					>
 					<File
+						RelativePath="..\..\src\orxonox\objects\controllers\AIController.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\controllers\ArtificialController.h"
+						>
+					</File>
+					<File
 						RelativePath="..\..\src\orxonox\objects\controllers\Controller.h"
 						>
@@ -1006,4 +1058,8 @@
 					<File
 						RelativePath="..\..\src\orxonox\objects\controllers\HumanController.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\controllers\ScriptController.h"
 						>
 					</File>
@@ -1133,4 +1189,20 @@
 					</Filter>
 				</Filter>
+				<Filter
+					Name="items"
+					>
+					<File
+						RelativePath="..\..\src\orxonox\objects\items\Engine.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\items\Item.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\items\MultiStateEngine.h"
+						>
+					</File>
+				</Filter>
 			</Filter>
 			<Filter
@@ -1147,4 +1219,8 @@
 				<File
 					RelativePath="..\..\src\orxonox\tools\ParticleInterface.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\orxonox\tools\Shader.h"
 					>
 				</File>