Index: code/branches/questsystem3/src/orxonox/objects/quest/AddQuest.cc
===================================================================
--- code/branches/questsystem3/src/orxonox/objects/quest/AddQuest.cc	(revision 2374)
+++ code/branches/questsystem3/src/orxonox/objects/quest/AddQuest.cc	(revision 2375)
@@ -108,5 +108,5 @@
         }
 
-        COUT(3) << "Quest {" << this->getQuestId() << "} successfully added to player." << std::endl;
+        COUT(3) << "Quest {" << this->getQuestId() << "} successfully added to player: " << player << " ." std::endl;
         return true;
     }
Index: code/branches/questsystem3/src/orxonox/objects/quest/AddQuestHint.cc
===================================================================
--- code/branches/questsystem3/src/orxonox/objects/quest/AddQuestHint.cc	(revision 2374)
+++ code/branches/questsystem3/src/orxonox/objects/quest/AddQuestHint.cc	(revision 2375)
@@ -129,5 +129,5 @@
         }
 
-        COUT(3) << "QuestHint {" << this->getHintId() << "} successfully added to player." << std::endl;
+        COUT(3) << "QuestHint {" << this->getHintId() << "} successfully added to player: " << player << " ." std::endl;
         return true;
 
Index: code/branches/questsystem3/src/orxonox/objects/quest/AddReward.cc
===================================================================
--- code/branches/questsystem3/src/orxonox/objects/quest/AddReward.cc	(revision 2374)
+++ code/branches/questsystem3/src/orxonox/objects/quest/AddReward.cc	(revision 2375)
@@ -105,4 +105,6 @@
     bool AddReward::invoke(PlayerInfo* player)
     {
+        COUT(3) << "AddReward on player: " << player << " ." << std::endl;
+        
         bool check = true;
         for ( std::list<Rewardable*>::iterator reward = this->rewards_.begin(); reward != this->rewards_.end(); ++reward )
@@ -110,4 +112,6 @@
             check = check && (*reward)->reward(player);
         }
+        
+        COUT(3) << "Rewardable successfully added to player." << player << " ." << std::endl;
 
         return check;
Index: code/branches/questsystem3/src/orxonox/objects/quest/Quest.cc
===================================================================
--- code/branches/questsystem3/src/orxonox/objects/quest/Quest.cc	(revision 2374)
+++ code/branches/questsystem3/src/orxonox/objects/quest/Quest.cc	(revision 2375)
@@ -377,4 +377,6 @@
         this->setStatus(player, questStatus::failed);
         
+        COUT(4) << "Quest {" << this->getId() << "} is failed for player: " << player << " ." <<std::endl;
+        
         this->getDescription()->sendFailQuestNotification();
         return true;
@@ -394,4 +396,6 @@
         this->setStatus(player, questStatus::completed);
         
+        COUT(4) << "Quest {" << this->getId() << "} is completed for player: " << player << " ." <<std::endl;
+        
         this->getDescription()->sendCompleteQuestNotification();
         return true;
@@ -413,4 +417,6 @@
             return false;
         }
+        
+        COUT(4) << "Quest {" << this->getId() << "} is started for player: " << player << " ." <<std::endl;
         
         QuestListener::advertiseStatusChange(this->listeners_, "start"); //!< Tells the QuestListeners, that the status has changed to active.
Index: code/branches/questsystem3/src/orxonox/objects/quest/QuestEffect.cc
===================================================================
--- code/branches/questsystem3/src/orxonox/objects/quest/QuestEffect.cc	(revision 2374)
+++ code/branches/questsystem3/src/orxonox/objects/quest/QuestEffect.cc	(revision 2375)
@@ -73,4 +73,6 @@
     {
         bool check = true;
+        
+        COUT(4) << "Invoking QuestEffects on player: " << player << " ."  << std::endl;
 
         for (std::list<QuestEffect*>::iterator effect = effects.begin(); effect != effects.end(); effect++)
Index: code/branches/questsystem3/src/orxonox/overlays/notifications/NotificationManager.cc
===================================================================
--- code/branches/questsystem3/src/orxonox/overlays/notifications/NotificationManager.cc	(revision 2374)
+++ code/branches/questsystem3/src/orxonox/overlays/notifications/NotificationManager.cc	(revision 2375)
@@ -47,4 +47,5 @@
     NotificationManager::~NotificationManager()
     {
+        //TDO: Destroy the containers
     }
     