Index: code/branches/presentation/src/network/GamestateManager.cc
===================================================================
--- code/branches/presentation/src/network/GamestateManager.cc	(revision 2381)
+++ code/branches/presentation/src/network/GamestateManager.cc	(revision 2382)
@@ -56,7 +56,9 @@
   GamestateManager::GamestateManager() {
     id_=0;
+    trafficControl_ = new TrafficControl();
   }
 
   GamestateManager::~GamestateManager() {
+    delete trafficControl_;
   }
 
Index: code/branches/presentation/src/network/GamestateManager.h
===================================================================
--- code/branches/presentation/src/network/GamestateManager.h	(revision 2381)
+++ code/branches/presentation/src/network/GamestateManager.h	(revision 2382)
@@ -43,4 +43,5 @@
 #include "NetworkPrereqs.h"
 #include "GamestateHandler.h"
+#include "TrafficControl.h"
 #include <map>
 
@@ -89,4 +90,5 @@
     std::map<unsigned int, packet::Gamestate*> gamestateQueue;
     packet::Gamestate *reference;
+    TrafficControl *trafficControl_;
     unsigned int id_;
   };
Index: code/branches/presentation/src/network/TrafficControl.cc
===================================================================
--- code/branches/presentation/src/network/TrafficControl.cc	(revision 2381)
+++ code/branches/presentation/src/network/TrafficControl.cc	(revision 2382)
@@ -30,4 +30,5 @@
 
 #include "synchronisable/Synchronisable.h"
+#include "core/ConfigValueIncludes.h"
 
 #include <cassert>
@@ -67,7 +68,9 @@
 	TrafficControl::TrafficControl()
 	{
+    RegisterRootObject(TrafficControl);
 	  assert(instance_==0);
 	  instance_=this;
-    targetSize = 1000;//5000bytes
+//     targetSize = 2500;//5000bytes
+    SetConfigValue ( targetSize, 28000./25. );
 	}
 	
@@ -127,4 +130,10 @@
 	  return;
 	}
+  
+  TrafficControl *TrafficControl::getInstance()
+  {
+    assert(instance_);
+    return instance_;
+  }
 	
 	void TrafficControl::ack(unsigned int clientID, unsigned int gamestateID)
@@ -347,5 +356,5 @@
     
     //now we check, that the creator of an object always exists on a client
-    printList(list, clientID);
+//     printList(list, clientID);
     std::list<obj>::iterator itcreator;
     for(itvec = list->begin(); itvec != list->end(); itvec++)
@@ -356,5 +365,5 @@
     //now the cutting, work the same obj out in processobjectlist and copiedlist, compression rate muss noch festgelegt werden. 
     cut(list, targetSize);
-    printList(list, clientID);
+//     printList(list, clientID);
     //diese Funktion updateClientList muss noch gemacht werden
     updateClientListTemp(list);
Index: code/branches/presentation/src/network/TrafficControl.h
===================================================================
--- code/branches/presentation/src/network/TrafficControl.h	(revision 2381)
+++ code/branches/presentation/src/network/TrafficControl.h	(revision 2382)
@@ -37,4 +37,5 @@
 #include <algorithm>
 #include "util/Integers.h"
+#include "core/OrxonoxClass.h"
 
 namespace orxonox {
@@ -78,5 +79,5 @@
 *
 */
-class TrafficControl{
+class TrafficControl : public OrxonoxClass{
   private:
 
@@ -153,4 +154,5 @@
     *Elements of struct i are therefore: *list[i].objID
     */
+    static TrafficControl *getInstance();
     void processObjectList(unsigned int clientID, unsigned int gamestateID, std::list<obj>* list); //gets a pointer to the list (containing objectIDs) and sorts it
     //done
Index: code/branches/presentation/src/network/packet/Gamestate.cc
===================================================================
--- code/branches/presentation/src/network/packet/Gamestate.cc	(revision 2381)
+++ code/branches/presentation/src/network/packet/Gamestate.cc	(revision 2382)
@@ -49,6 +49,4 @@
 
 #define PACKET_FLAG_GAMESTATE  ENET_PACKET_FLAG_RELIABLE
-  
-TrafficControl Gamestate::trafficControl_;
 
 Gamestate::Gamestate()
@@ -362,5 +360,5 @@
 
   //call TrafficControl
-  trafficControl_.processObjectList( clientID, HEADER->id, &dataMap_ );
+  TrafficControl::getInstance()->processObjectList( clientID, HEADER->id, &dataMap_ );
   
   //copy in the zeros
Index: code/branches/presentation/src/network/packet/Gamestate.h
===================================================================
--- code/branches/presentation/src/network/packet/Gamestate.h	(revision 2381)
+++ code/branches/presentation/src/network/packet/Gamestate.h	(revision 2382)
@@ -95,5 +95,5 @@
     void removeObject(ObjectListIterator<Synchronisable> &it);
     std::list<obj> dataMap_;
-    static TrafficControl trafficControl_;
+//     static TrafficControl *trafficControl_;
 };
 