Index: code/branches/questsystem3/src/orxonox/objects/quest/LocalQuest.h
===================================================================
--- code/branches/questsystem3/src/orxonox/objects/quest/LocalQuest.h	(revision 2382)
+++ code/branches/questsystem3/src/orxonox/objects/quest/LocalQuest.h	(revision 2383)
@@ -55,23 +55,23 @@
             <QuestDescription title="Title" description="Description." /> //The description of the quest.
             <subquests>
-        <Quest id ="questId1" /> //A list of n subquest, be aware, each of the <Quest /> tags must have a description and so on and so forth as well.
-        ...
-        <Quest id="questIdn" />
-        </subquests>
-        <hints>
-        <QuestHint id="hintId1" /> //A list of n QuestHints, see QuestHint for the full XML representation of those.
-        ...
-        <QuestHint id="hintIdn" />
-        </hints>
-    <fail-effects>
-        <QuestEffect /> //A list of QuestEffects, invoked when the Quest is failed, see QuestEffect for the full XML representation.
-        ...
-        <QuestEffect />
-    </fail-effects>
-    <complete-effects>
-        <QuestEffect /> //A list of QuestEffects, invoked when the Quest is completed, see QuestEffect for the full XML representation.
-        ...
-        <QuestEffect />
-    </complete-effects>
+                <Quest id ="questId1" /> //A list of n subquest, be aware, each of the <Quest /> tags must have a description and so on and so forth as well.
+                ...
+                <Quest id="questIdn" />
+                </subquests>
+                <hints>
+                <QuestHint id="hintId1" /> //A list of n QuestHints, see QuestHint for the full XML representation of those.
+                ...
+                <QuestHint id="hintIdn" />
+                </hints>
+            <fail-effects>
+                <QuestEffect /> //A list of QuestEffects, invoked when the Quest is failed, see QuestEffect for the full XML representation.
+                ...
+                <QuestEffect />
+            </fail-effects>
+            <complete-effects>
+                <QuestEffect /> //A list of QuestEffects, invoked when the Quest is completed, see QuestEffect for the full XML representation.
+                ...
+                <QuestEffect />
+            </complete-effects>
         </LocalQuest>
     @author
Index: code/branches/questsystem3/src/orxonox/objects/quest/QuestHint.h
===================================================================
--- code/branches/questsystem3/src/orxonox/objects/quest/QuestHint.h	(revision 2382)
+++ code/branches/questsystem3/src/orxonox/objects/quest/QuestHint.h	(revision 2383)
@@ -46,5 +46,5 @@
 {
 
-    //! The status of the hint.
+    //! The state of the hint.
     enum Enum
     {
@@ -95,5 +95,5 @@
         private:
             Quest* quest_; //!< The Quest the QuestHint belongs to.
-            std::map<const PlayerInfo*, questHintStatus::Enum> playerStatus_; //!< List of the status for each player, with the Player-pointer as key.
+            std::map<const PlayerInfo*, questHintStatus::Enum> playerStatus_; //!< List of the states for each player, with the Player-pointer as key.
 
     };
Index: code/branches/questsystem3/src/orxonox/objects/quest/QuestItem.cc
===================================================================
--- code/branches/questsystem3/src/orxonox/objects/quest/QuestItem.cc	(revision 2382)
+++ code/branches/questsystem3/src/orxonox/objects/quest/QuestItem.cc	(revision 2383)
@@ -98,6 +98,4 @@
     @return
         Returns true if the string is likely to be of the required form.
-    @todo
-        Clarify form, more vigorous checks.
     */
     /*static*/ bool QuestItem::isId(const std::string & id)
Index: code/branches/questsystem3/src/orxonox/objects/quest/QuestListener.cc
===================================================================
--- code/branches/questsystem3/src/orxonox/objects/quest/QuestListener.cc	(revision 2382)
+++ code/branches/questsystem3/src/orxonox/objects/quest/QuestListener.cc	(revision 2383)
@@ -37,4 +37,5 @@
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
+#include "util/Exception.h"
 
 #include "Quest.h"
@@ -115,5 +116,5 @@
         if(this->quest_ == NULL) //!< If there is no such Quest.
         {
-            COUT(1) << "This is bad! The QuestListener has not found a Quest qith a corresponding id." << std::endl; //TDO Throw a damn Exception!
+            ThrowException(Argument, "This is bad! The QuestListener has not found a Quest with a corresponding id..");
             return false;
         }
@@ -197,5 +198,5 @@
     bool QuestListener::execute()
     {
-        this->fireEvent(true); //TDO This' right?
+        this->fireEvent(true);
         return true;
     }
Index: code/branches/questsystem3/src/orxonox/overlays/notifications/Notification.h
===================================================================
--- code/branches/questsystem3/src/orxonox/overlays/notifications/Notification.h	(revision 2382)
+++ code/branches/questsystem3/src/orxonox/overlays/notifications/Notification.h	(revision 2383)
@@ -40,5 +40,5 @@
     /**
     @brief
-	
+	This is rather temporary, so don't start relying on it, some better version will come soon but the Interface will not likely be the same.
     @author
         Damian 'Mozork' Frick