Index: code/branches/buildsystem/src/audio/CMakeLists.txt
===================================================================
--- code/branches/buildsystem/src/audio/CMakeLists.txt	(revision 2336)
+++ code/branches/buildsystem/src/audio/CMakeLists.txt	(revision 2384)
@@ -21,3 +21,3 @@
 )
 
-
+INSTALL(TARGETS audio LIBRARY DESTINATION lib)
Index: code/branches/buildsystem/src/ceguilua-0.5.0/ceguilua/CMakeLists.txt
===================================================================
--- code/branches/buildsystem/src/ceguilua-0.5.0/ceguilua/CMakeLists.txt	(revision 2336)
+++ code/branches/buildsystem/src/ceguilua-0.5.0/ceguilua/CMakeLists.txt	(revision 2384)
@@ -13,2 +13,4 @@
   ${CEGUI_LIBRARY}
 )
+
+INSTALL(TARGETS ceguilua_orxonox LIBRARY DESTINATION lib)
Index: code/branches/buildsystem/src/ceguilua-0.6.1/ceguilua/CMakeLists.txt
===================================================================
--- code/branches/buildsystem/src/ceguilua-0.6.1/ceguilua/CMakeLists.txt	(revision 2336)
+++ code/branches/buildsystem/src/ceguilua-0.6.1/ceguilua/CMakeLists.txt	(revision 2384)
@@ -13,2 +13,4 @@
   ${CEGUI_LIBRARY}
 )
+
+INSTALL(TARGETS ceguilua_orxonox LIBRARY DESTINATION lib)
Index: code/branches/buildsystem/src/core/CMakeLists.txt
===================================================================
--- code/branches/buildsystem/src/core/CMakeLists.txt	(revision 2336)
+++ code/branches/buildsystem/src/core/CMakeLists.txt	(revision 2384)
@@ -68,2 +68,4 @@
   util
 )
+
+INSTALL(TARGETS core LIBRARY DESTINATION lib)
Index: code/branches/buildsystem/src/cpptcl/CMakeLists.txt
===================================================================
--- code/branches/buildsystem/src/cpptcl/CMakeLists.txt	(revision 2336)
+++ code/branches/buildsystem/src/cpptcl/CMakeLists.txt	(revision 2384)
@@ -4,2 +4,4 @@
   ${TCL_LIBRARY}
 )
+
+INSTALL(TARGETS cpptcl_orxonox LIBRARY DESTINATION lib)
Index: code/branches/buildsystem/src/network/CMakeLists.txt
===================================================================
--- code/branches/buildsystem/src/network/CMakeLists.txt	(revision 2336)
+++ code/branches/buildsystem/src/network/CMakeLists.txt	(revision 2384)
@@ -32,4 +32,5 @@
 )
 
+INSTALL(TARGETS network LIBRARY DESTINATION lib)
 
 # build those parts only on request.
Index: code/branches/buildsystem/src/ois/CMakeLists.txt
===================================================================
--- code/branches/buildsystem/src/ois/CMakeLists.txt	(revision 2336)
+++ code/branches/buildsystem/src/ois/CMakeLists.txt	(revision 2384)
@@ -46,2 +46,3 @@
 ENDIF(WIN32)
 
+INSTALL(TARGETS ois_orxonox LIBRARY DESTINATION lib)
Index: code/branches/buildsystem/src/orxonox/CMakeLists.txt
===================================================================
--- code/branches/buildsystem/src/orxonox/CMakeLists.txt	(revision 2336)
+++ code/branches/buildsystem/src/orxonox/CMakeLists.txt	(revision 2384)
@@ -101,2 +101,4 @@
   network
 )
+
+INSTALL(TARGETS orxonox RUNTIME DESTINATION bin)
Index: code/branches/buildsystem/src/tinyxml/CMakeLists.txt
===================================================================
--- code/branches/buildsystem/src/tinyxml/CMakeLists.txt	(revision 2336)
+++ code/branches/buildsystem/src/tinyxml/CMakeLists.txt	(revision 2384)
@@ -8,2 +8,3 @@
 
 ADD_LIBRARY(tinyxml_orxonox SHARED ${TINYXML_SRC_FILES})
+INSTALL(TARGETS tinyxml_orxonox LIBRARY DESTINATION lib)
Index: code/branches/buildsystem/src/tolua/CMakeLists.txt
===================================================================
--- code/branches/buildsystem/src/tolua/CMakeLists.txt	(revision 2336)
+++ code/branches/buildsystem/src/tolua/CMakeLists.txt	(revision 2384)
@@ -9,5 +9,5 @@
 ADD_LIBRARY          (tolualib_orxonox SHARED ${TOLUALIB_SRC_FILES})
 TARGET_LINK_LIBRARIES(tolualib_orxonox ${LUA_LIBRARIES})
-
+INSTALL(TARGETS tolualib_orxonox LIBRARY DESTINATION lib)
 
 SET(TOLUAGEN_SRC_FILES
Index: code/branches/buildsystem/src/util/CMakeLists.txt
===================================================================
--- code/branches/buildsystem/src/util/CMakeLists.txt	(revision 2336)
+++ code/branches/buildsystem/src/util/CMakeLists.txt	(revision 2384)
@@ -14,4 +14,5 @@
 ADD_LIBRARY(util SHARED ${UTIL_SRC_FILES})
 TARGET_LINK_LIBRARIES(util ${OGRE_LIBRARY})
+INSTALL(TARGETS util LIBRARY DESTINATION lib)
 
 ADD_SUBDIRECTORY(testing)