Index: code/branches/overlay/src/orxonox/overlays/stats/CreateLines.cc
===================================================================
--- code/branches/overlay/src/orxonox/overlays/stats/CreateLines.cc	(revision 2320)
+++ code/branches/overlay/src/orxonox/overlays/stats/CreateLines.cc	(revision 2386)
@@ -67,9 +67,13 @@
         Ogre::OverlayManager* ovMan = Ogre::OverlayManager::getSingletonPtr();
 
+        unsigned int colIndex = 0;
+
         while (textColumns_.size() < numberOfColumns) {
 
-            Ogre::TextAreaOverlayElement* tempTextArea = static_cast<Ogre::TextAreaOverlayElement*>(ovMan->createOverlayElement("TextArea", "StatsLineTextArea" + getName() + convertToString(lineIndex)));
+            Ogre::TextAreaOverlayElement* tempTextArea = static_cast<Ogre::TextAreaOverlayElement*>(ovMan->createOverlayElement("TextArea", "StatsLineTextArea" + getName() + convertToString(lineIndex) + convertToString(colIndex)));
             textColumns_.push_back(tempTextArea);
             this->background_->addChild(tempTextArea);
+
+            colIndex++;
 
         }
Index: code/branches/overlay/src/orxonox/overlays/stats/Scoreboard.cc
===================================================================
--- code/branches/overlay/src/orxonox/overlays/stats/Scoreboard.cc	(revision 2320)
+++ code/branches/overlay/src/orxonox/overlays/stats/Scoreboard.cc	(revision 2386)
@@ -52,4 +52,20 @@
     {
         RegisterObject(Scoreboard);
+
+        createlines_ = new CreateLines(this);
+        // this->gametype_ = new Gametype(this);
+    }
+
+    /**
+        @brief Initializes the lines.
+    */
+    void Scoreboard::XMLPort(Element& xmlElement, XMLPort::Mode mode)
+    {
+        SUPER(Scoreboard, XMLPort, xmlElement, mode);
+
+        printLines();
+
+        COUT(0) << "XMLPort executed." << std::endl;
+
     }
 
@@ -60,23 +76,26 @@
 
         numberOfColumns = 2;
-        numberOfLines = this->gametype_->getNumberOfPlayers();
-        columnIndex = 0;
-        topOffset = 0.3;
+        // numberOfLines = this->gametype_->getNumberOfPlayers();
+        numberOfLines = 3;
+        topOffset = 0.1;
         lineSpacing = 0.1;
 
         for (unsigned int i = 0; i < numberOfLines; i++) {
 
-            leftOffset = 0.3;
+            columnIndex = 0;
+            leftOffset = 0.1;
 
             this->createlines_->setNumberOfColumns(numberOfColumns, i);
 
-            columnText = this->gametype_->getPlayersName();
+            // columnText = this->gametype_->getPlayersName();
+            columnText = "PlayerName";
             this->createlines_->alignColumn(columnIndex, topOffset, leftOffset);
             this->createlines_->setColumnText(columnIndex, columnText);
 
             columnIndex++;
-            leftOffset = leftOffset + 0.4;
+            leftOffset = leftOffset + 0.3;
 
-            columnText = this->gametype_->getPlayersFrags();
+            // columnText = this->gametype_->getPlayersFrags();
+            columnText = "PlayerFrags";
             this->createlines_->alignColumn(columnIndex, topOffset, leftOffset);
             this->createlines_->setColumnText(columnIndex, columnText);
Index: code/branches/overlay/src/orxonox/overlays/stats/Scoreboard.h
===================================================================
--- code/branches/overlay/src/orxonox/overlays/stats/Scoreboard.h	(revision 2320)
+++ code/branches/overlay/src/orxonox/overlays/stats/Scoreboard.h	(revision 2386)
@@ -47,4 +47,6 @@
         ~Scoreboard() {}
 
+        virtual void XMLPort(Element& xmlElement, XMLPort::Mode mode);
+
         inline void setGametype(Gametype* gt)
             { this->gametype_ = gt; }
Index: code/branches/overlay/src/orxonox/overlays/stats/Stats.cc
===================================================================
--- code/branches/overlay/src/orxonox/overlays/stats/Stats.cc	(revision 2320)
+++ code/branches/overlay/src/orxonox/overlays/stats/Stats.cc	(revision 2386)
@@ -101,8 +101,4 @@
     }
 
-    /**
-        @brief Used to control the actual scrolling and the cursor.
-    */
-
     void Stats::tick(float dt)
     {